##// END OF EJS Templates
Update rpi23-gen-image.sh
burnbabyburn -
r641:a892d3d16be3
parent child
Show More
@@ -1,886 +1,887
1 1 #!/bin/sh
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=2}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47
48 48 # Kernel Branch
49 49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 50
51 51 # URLs
52 52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
60 60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
61 61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
62 62
63 63 # Kernel deb packages for 32bit kernel
64 64 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
65 65 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
66 66 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
67 67 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
68 68 # Default precompiled 64bit kernel
69 69 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
70 70 # Sakaki BIS Kernel RPI4
71 71 RPI4_64_DEF_KERNEL_URL=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz
72 72 # Generic
73 73 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
74 74 RPI4_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
75 75 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
76 76 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
77 77
78 78 # Build directories
79 79 WORKDIR=$(pwd)
80 80 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
81 81 BUILDDIR="${BASEDIR}/build"
82 82
83 83 # Chroot directories
84 84 R="${BUILDDIR}/chroot"
85 85 ETC_DIR="${R}/etc"
86 86 LIB_DIR="${R}/lib"
87 87 BOOT_DIR="${R}/boot/firmware"
88 88 KERNEL_DIR="${R}/usr/src/linux"
89 89 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
90 90 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
91 91
92 92 # Firmware directory: Blank if download from github
93 93 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
94 94
95 95 # General settings
96 96 SET_ARCH=${SET_ARCH:=32}
97 97 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
98 98 PASSWORD=${PASSWORD:=raspberry}
99 99 USER_PASSWORD=${USER_PASSWORD:=raspberry}
100 100 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
101 101 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
102 102 EXPANDROOT=${EXPANDROOT:=true}
103 103 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
104 104
105 105 # Keyboard settings
106 106 XKB_MODEL=${XKB_MODEL:=""}
107 107 XKB_LAYOUT=${XKB_LAYOUT:=""}
108 108 XKB_VARIANT=${XKB_VARIANT:=""}
109 109 XKB_OPTIONS=${XKB_OPTIONS:=""}
110 110
111 111 # Network settings (DHCP)
112 112 ENABLE_DHCP=${ENABLE_DHCP:=true}
113 113
114 114 # Network settings (static)
115 115 NET_ADDRESS=${NET_ADDRESS:=""}
116 116 NET_GATEWAY=${NET_GATEWAY:=""}
117 117 NET_DNS_1=${NET_DNS_1:=""}
118 118 NET_DNS_2=${NET_DNS_2:=""}
119 119 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
120 120 NET_NTP_1=${NET_NTP_1:=""}
121 121 NET_NTP_2=${NET_NTP_2:=""}
122 122
123 123 # APT settings
124 124 APT_PROXY=${APT_PROXY:=""}
125 125 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
126 126 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
127 127
128 128 # Feature settings
129 129 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
130 130 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
131 131 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
132 132 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
133 133 ENABLE_I2C=${ENABLE_I2C:=false}
134 134 ENABLE_SPI=${ENABLE_SPI:=false}
135 135 ENABLE_IPV6=${ENABLE_IPV6:=true}
136 136 ENABLE_SSHD=${ENABLE_SSHD:=true}
137 137 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
138 138 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
139 139 ENABLE_SOUND=${ENABLE_SOUND:=true}
140 140 ENABLE_DBUS=${ENABLE_DBUS:=true}
141 141 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
142 142 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
143 143 ENABLE_XORG=${ENABLE_XORG:=false}
144 144 ENABLE_WM=${ENABLE_WM:=""}
145 145 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
146 146 ENABLE_USER=${ENABLE_USER:=true}
147 147 USER_NAME=${USER_NAME:="pi"}
148 148 ENABLE_ROOT=${ENABLE_ROOT:=false}
149 149 ENABLE_QEMU=${ENABLE_QEMU:=false}
150 150 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
151 151
152 152 # SSH settings
153 153 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
154 154 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
155 155 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
156 156 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
157 157 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
158 158
159 159 # Advanced settings
160 160 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
161 161 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
162 162 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
163 163 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
164 164 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
165 165 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
166 166 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
167 167 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
168 168 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
169 169 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
170 170 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
171 171 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
172 172 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
173 173 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
174 174 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
175 175 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
176 176 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
177 177 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
178 178 ENABLE_LOGO=${ENABLE_LOGO:=true}
179 179 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
180 180 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
181 181
182 182 # Kernel compilation settings
183 183 BUILD_KERNEL=${BUILD_KERNEL:=true}
184 184 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
185 185 KERNEL_THREADS=${KERNEL_THREADS:=1}
186 186 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
187 187 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
188 188 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
189 189 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
190 190 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
191 191 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
192 192 KERNEL_VIRT=${KERNEL_VIRT:=false}
193 193 KERNEL_BPF=${KERNEL_BPF:=false}
194 194 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
195 195 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
196 196 KERNEL_NF=${KERNEL_NF:=false}
197 197
198 198 # Kernel compilation from source directory settings
199 199 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
200 200 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
201 201 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
202 202 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
203 203
204 204 # Reduce disk usage settings
205 205 REDUCE_APT=${REDUCE_APT:=true}
206 206 REDUCE_DOC=${REDUCE_DOC:=true}
207 207 REDUCE_MAN=${REDUCE_MAN:=true}
208 208 REDUCE_VIM=${REDUCE_VIM:=false}
209 209 REDUCE_BASH=${REDUCE_BASH:=false}
210 210 REDUCE_HWDB=${REDUCE_HWDB:=true}
211 211 REDUCE_SSHD=${REDUCE_SSHD:=true}
212 212 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
213 213
214 214 # Encrypted filesystem settings
215 215 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
216 216 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
217 217 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
218 218 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
219 219 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
220 220 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
221 221 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
222 222 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
223 223 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
224 224
225 225 # Chroot scripts directory
226 226 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
227 227
228 228 # Packages required in the chroot build environment
229 229 APT_INCLUDES=${APT_INCLUDES:=""}
230 230 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
231 231
232 232 # Packages to exclude from chroot build environment
233 233 APT_EXCLUDES=${APT_EXCLUDES:=""}
234 234
235 235 # Packages required for bootstrapping
236 236 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
237 237 MISSING_PACKAGES=""
238 238
239 239 # Packages installed for c/c++ build environment in chroot (keep empty)
240 240 COMPILER_PACKAGES=""
241 241
242 242 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
243 243 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
244 244 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
245 245 APT_PROXY=http://127.0.0.1:3142/
246 246 fi
247 247
248 248 # Setup architecture specific settings
249 249 if [ -n "$SET_ARCH" ] ; then
250 250 # 64-bit configuration
251 251 if [ "$SET_ARCH" = 64 ] ; then
252 252 # General 64-bit depended settings
253 253 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
254 254 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
255 255 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
256 256
257 257 # Raspberry Pi model specific settings
258 258 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
259 259 if [ "$RPI_MODEL" != 4 ] ; then
260 260 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
261 261 else
262 262 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
263 263 fi
264 264
265 265 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
266 266 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
267 267 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
268 268 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
269 269 else
270 270 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
271 271 exit 1
272 272 fi
273 273 fi
274 274
275 275 # 32-bit configuration
276 276 if [ "$SET_ARCH" = 32 ] ; then
277 277 # General 32-bit dependend settings
278 278 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
279 279 KERNEL_ARCH=${KERNEL_ARCH:=arm}
280 280 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
281 281
282 282 # Raspberry Pi model specific settings
283 283 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
284 284 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
285 285 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
286 286 RELEASE_ARCH=${RELEASE_ARCH:=armel}
287 287 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
288 288 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
289 289 fi
290 290
291 291 # Raspberry Pi model specific settings
292 292 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
293 293 if [ "$RPI_MODEL" != 4 ] ; then
294 294 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
295 295 else
296 296 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
297 297 fi
298 298
299 299 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
300 300 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
301 301 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
302 302 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
303 303 fi
304 304 fi
305 305 # SET_ARCH not set
306 306 else
307 307 echo "error: Please set '32' or '64' as value for SET_ARCH"
308 308 exit 1
309 309 fi
310 310 # Device specific configuration and U-Boot configuration
311 311 case "$RPI_MODEL" in
312 312 0)
313 313 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
314 314 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
315 315 ;;
316 316 1)
317 317 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
318 318 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
319 319 ;;
320 320 1P)
321 321 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
322 322 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
323 323 ;;
324 324 2)
325 325 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
326 326 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
327 327 ;;
328 328 3)
329 329 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
330 330 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
331 331 ;;
332 332 3P)
333 333 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
334 334 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
335 335 ;;
336 336 4)
337 337 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
338 338 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
339 339 ;;
340 340 *)
341 341 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
342 342 exit 1
343 343 ;;
344 344 esac
345 345
346 346 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
347 347 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
348 348 # Include bluetooth packages on supported boards
349 349 if [ "$ENABLE_BLUETOOTH" = true ] ; then
350 350 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
351 351 fi
352 352 if [ "$ENABLE_WIRELESS" = true ] ; then
353 353 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb"
354 354 fi
355 355 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
356 356 # Check if the internal wireless interface is not supported by the RPi model
357 357 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
358 358 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
359 359 exit 1
360 360 fi
361 361 fi
362 362
363 363 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
364 364 echo "error: You have to compile kernel sources, if you want to enable nexmon"
365 365 exit 1
366 366 fi
367 367
368 368 # Prepare date string for default image file name
369 369 DATE="$(date +%Y-%m-%d)"
370 370 if [ -z "$KERNEL_BRANCH" ] ; then
371 371 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
372 372 else
373 373 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
374 374 fi
375 375
376 376 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
377 377 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
378 378 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
379 379 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
380 380 exit 1
381 381 fi
382 382 fi
383 383
384 384 # Add cmake to compile videocore sources
385 385 if [ "$ENABLE_VIDEOCORE" = true ] ; then
386 386 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
387 387 fi
388 388
389 389 # Add deps for nexmon
390 390 if [ "$ENABLE_NEXMON" = true ] ; then
391 391 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
392 392 fi
393 393
394 394 # Add libncurses5 to enable kernel menuconfig
395 395 if [ "$KERNEL_MENUCONFIG" = true ] ; then
396 396 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
397 397 fi
398 398
399 399 # Add ccache compiler cache for (faster) kernel cross (re)compilation
400 400 if [ "$KERNEL_CCACHE" = true ] ; then
401 401 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
402 402 fi
403 403
404 404 # Add cryptsetup package to enable filesystem encryption
405 405 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
406 406 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
407 407 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
408 408
409 409 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
410 410 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
411 411 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
412 412 fi
413 413
414 414 if [ -z "$CRYPTFS_PASSWORD" ] ; then
415 415 echo "error: no password defined (CRYPTFS_PASSWORD)!"
416 416 exit 1
417 417 fi
418 418 ENABLE_INITRAMFS=true
419 419 fi
420 420
421 421 # Add initramfs generation tools
422 422 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
423 423 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
424 424 fi
425 425
426 426 # Add device-tree-compiler required for building the U-Boot bootloader
427 427 if [ "$ENABLE_UBOOT" = true ] ; then
428 428 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
429 429 fi
430 430
431 431 if [ "$ENABLE_USBBOOT" = true ] ; then
432 432 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
433 433 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
434 434 exit 1
435 435 fi
436 436 fi
437 437
438 438 # Check if root SSH (v2) public key file exists
439 439 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
440 440 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
441 441 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
442 442 exit 1
443 443 fi
444 444 fi
445 445
446 446 # Check if $USER_NAME SSH (v2) public key file exists
447 447 if [ -n "$SSH_USER_PUB_KEY" ] ; then
448 448 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
449 449 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
450 450 exit 1
451 451 fi
452 452 fi
453 453
454 454 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
455 455 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
456 456 exit 1
457 457 fi
458 458
459 459 # Check if all required packages are installed on the build system
460 460 for package in $REQUIRED_PACKAGES ; do
461 461 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
462 462 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
463 463 fi
464 464 done
465 465
466 466 # If there are missing packages ask confirmation for install, or exit
467 467 if [ -n "$MISSING_PACKAGES" ] ; then
468 468 echo "the following packages needed by this script are not installed:"
469 469 echo "$MISSING_PACKAGES"
470 470
471 471 printf "\ndo you want to install the missing packages right now? [y/n] "
472 472 read -r confirm
473 473 [ "$confirm" != "y" ] && exit 1
474 474
475 475 # Make sure all missing required packages are installed
476 apt-get -qq -y install "$(echo "${MISSING_PACKAGES}" | sed "s/ //")"
476 apt-get update
477 apt-get -qq -y install "$MISSING_PACKAGES"
477 478 fi
478 479
479 480 # Check if ./bootstrap.d directory exists
480 481 if [ ! -d "./bootstrap.d/" ] ; then
481 482 echo "error: './bootstrap.d' required directory not found!"
482 483 exit 1
483 484 fi
484 485
485 486 # Check if ./files directory exists
486 487 if [ ! -d "./files/" ] ; then
487 488 echo "error: './files' required directory not found!"
488 489 exit 1
489 490 fi
490 491
491 492 # Check if specified KERNELSRC_DIR directory exists
492 493 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
493 494 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
494 495 exit 1
495 496 fi
496 497
497 498 # Check if specified UBOOTSRC_DIR directory exists
498 499 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
499 500 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
500 501 exit 1
501 502 fi
502 503
503 504 # Check if specified VIDEOCORESRC_DIR directory exists
504 505 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
505 506 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
506 507 exit 1
507 508 fi
508 509
509 510 # Check if specified FBTURBOSRC_DIR directory exists
510 511 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
511 512 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
512 513 exit 1
513 514 fi
514 515
515 516 # Check if specified NEXMONSRC_DIR directory exists
516 517 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
517 518 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
518 519 exit 1
519 520 fi
520 521
521 522 # Check if specified CHROOT_SCRIPTS directory exists
522 523 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
523 524 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
524 525 exit 1
525 526 fi
526 527
527 528 # Check if specified device mapping already exists (will be used by cryptsetup)
528 529 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
529 530 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
530 531 exit 1
531 532 fi
532 533
533 534 # Don't clobber an old build
534 535 if [ -e "$BUILDDIR" ] ; then
535 536 echo "error: directory ${BUILDDIR} already exists, not proceeding"
536 537 exit 1
537 538 fi
538 539
539 540 # Setup chroot directory
540 541 mkdir -p "${R}"
541 542
542 543 # Check if build directory has enough of free disk space >512MB
543 544 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
544 545 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
545 546 exit 1
546 547 fi
547 548
548 549 set -x
549 550
550 551 # Call "cleanup" function on various signals and errors
551 552 trap cleanup 0 1 2 3 6
552 553
553 554 # Add required packages for the minbase installation
554 555 if [ "$ENABLE_MINBASE" = true ] ; then
555 556 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
556 557 fi
557 558
558 559 # Add parted package, required to get partprobe utility
559 560 if [ "$EXPANDROOT" = true ] ; then
560 561 APT_INCLUDES="${APT_INCLUDES},parted"
561 562 fi
562 563
563 564 # Add dphys-swapfile package, required to enable swap
564 565 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
565 566 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
566 567 fi
567 568
568 569 # Add dbus package, recommended if using systemd
569 570 if [ "$ENABLE_DBUS" = true ] ; then
570 571 APT_INCLUDES="${APT_INCLUDES},dbus"
571 572 fi
572 573
573 574 # Add iptables IPv4/IPv6 package
574 575 if [ "$ENABLE_IPTABLES" = true ] ; then
575 576 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
576 577 fi
577 578 # Add apparmor for KERNEL_SECURITY
578 579 if [ "$KERNEL_SECURITY" = true ] ; then
579 580 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
580 581 fi
581 582
582 583 # Add openssh server package
583 584 if [ "$ENABLE_SSHD" = true ] ; then
584 585 APT_INCLUDES="${APT_INCLUDES},openssh-server"
585 586 fi
586 587
587 588 # Add alsa-utils package
588 589 if [ "$ENABLE_SOUND" = true ] ; then
589 590 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
590 591 fi
591 592
592 593 # Add rng-tools package
593 594 if [ "$ENABLE_HWRANDOM" = true ] ; then
594 595 APT_INCLUDES="${APT_INCLUDES},rng-tools"
595 596 fi
596 597
597 598 # Add fbturbo video driver
598 599 if [ "$ENABLE_FBTURBO" = true ] ; then
599 600 # Enable xorg package dependencies
600 601 ENABLE_XORG=true
601 602 fi
602 603
603 604 # Add user defined window manager package
604 605 if [ -n "$ENABLE_WM" ] ; then
605 606 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
606 607
607 608 # Enable xorg package dependencies
608 609 ENABLE_XORG=true
609 610 fi
610 611
611 612 # Add xorg package
612 613 if [ "$ENABLE_XORG" = true ] ; then
613 614 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
614 615 fi
615 616
616 617 # Replace selected packages with smaller clones
617 618 if [ "$ENABLE_REDUCE" = true ] ; then
618 619 # Add levee package instead of vim-tiny
619 620 if [ "$REDUCE_VIM" = true ] ; then
620 621 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
621 622 fi
622 623
623 624 # Add dropbear package instead of openssh-server
624 625 if [ "$REDUCE_SSHD" = true ] ; then
625 626 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
626 627 fi
627 628 fi
628 629
629 630 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
630 631 if [ "$ENABLE_SYSVINIT" = false ] ; then
631 632 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
632 633 fi
633 634
634 635 # Configure kernel sources if no KERNELSRC_DIR
635 636 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
636 637 KERNELSRC_CONFIG=true
637 638 fi
638 639
639 640 # Configure reduced kernel
640 641 if [ "$KERNEL_REDUCE" = true ] ; then
641 642 KERNELSRC_CONFIG=false
642 643 fi
643 644
644 645 # Configure qemu compatible kernel
645 646 if [ "$ENABLE_QEMU" = true ] ; then
646 647 DTB_FILE=vexpress-v2p-ca15_a7.dtb
647 648 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
648 649 KERNEL_DEFCONFIG="vexpress_defconfig"
649 650 if [ "$KERNEL_MENUCONFIG" = false ] ; then
650 651 KERNEL_OLDDEFCONFIG=true
651 652 fi
652 653 fi
653 654
654 655 # Execute bootstrap scripts
655 656 for SCRIPT in bootstrap.d/*.sh; do
656 657 head -n 3 "$SCRIPT"
657 658 . "$SCRIPT"
658 659 done
659 660
660 661 ## Execute custom bootstrap scripts
661 662 if [ -d "custom.d" ] ; then
662 663 for SCRIPT in custom.d/*.sh; do
663 664 . "$SCRIPT"
664 665 done
665 666 fi
666 667
667 668 # Execute custom scripts inside the chroot
668 669 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
669 670 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
670 671 chroot_exec /bin/bash -x <<'EOF'
671 672 for SCRIPT in /chroot_scripts/* ; do
672 673 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
673 674 $SCRIPT
674 675 fi
675 676 done
676 677 EOF
677 678 rm -rf "${R}/chroot_scripts"
678 679 fi
679 680
680 681 # Remove c/c++ build environment from the chroot
681 682 chroot_remove_cc
682 683
683 684 # Generate required machine-id
684 685 MACHINE_ID=$(dbus-uuidgen)
685 686 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
686 687 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
687 688
688 689 # APT Cleanup
689 690 chroot_exec apt-get -y clean
690 691 chroot_exec apt-get -y autoclean
691 692 chroot_exec apt-get -y autoremove
692 693
693 694 # Unmount mounted filesystems
694 695 umount -l "${R}/proc"
695 696 umount -l "${R}/sys"
696 697
697 698 # Clean up directories
698 699 rm -rf "${R}/run/*"
699 700 rm -rf "${R}/tmp/*"
700 701
701 702 # Clean up APT proxy settings
702 703 if [ "$KEEP_APT_PROXY" = false ] ; then
703 704 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
704 705 fi
705 706
706 707 # Clean up files
707 708 rm -f "${ETC_DIR}/ssh/ssh_host_*"
708 709 rm -f "${ETC_DIR}/dropbear/dropbear_*"
709 710 rm -f "${ETC_DIR}/apt/sources.list.save"
710 711 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
711 712 rm -f "${ETC_DIR}/*-"
712 713 rm -f "${ETC_DIR}/resolv.conf"
713 714 rm -f "${R}/root/.bash_history"
714 715 rm -f "${R}/var/lib/urandom/random-seed"
715 716 rm -f "${R}/initrd.img"
716 717 rm -f "${R}/vmlinuz"
717 718 rm -f "${R}${QEMU_BINARY}"
718 719
719 720 if [ "$ENABLE_QEMU" = true ] ; then
720 721 # Setup QEMU directory
721 722 mkdir "${BASEDIR}/qemu"
722 723
723 724 # Copy kernel image to QEMU directory
724 725 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
725 726
726 727 # Copy kernel config to QEMU directory
727 728 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
728 729
729 730 # Copy kernel dtbs to QEMU directory
730 731 for dtb in "${BOOT_DIR}/"*.dtb ; do
731 732 if [ -f "${dtb}" ] ; then
732 733 install_readonly "${dtb}" "${BASEDIR}/qemu/"
733 734 fi
734 735 done
735 736
736 737 # Copy kernel overlays to QEMU directory
737 738 if [ -d "${BOOT_DIR}/overlays" ] ; then
738 739 # Setup overlays dtbs directory
739 740 mkdir "${BASEDIR}/qemu/overlays"
740 741
741 742 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
742 743 if [ -f "${dtb}" ] ; then
743 744 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
744 745 fi
745 746 done
746 747 fi
747 748
748 749 # Copy u-boot files to QEMU directory
749 750 if [ "$ENABLE_UBOOT" = true ] ; then
750 751 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
751 752 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
752 753 fi
753 754 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
754 755 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
755 756 fi
756 757 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
757 758 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
758 759 fi
759 760 fi
760 761
761 762 # Copy initramfs to QEMU directory
762 763 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
763 764 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
764 765 fi
765 766 fi
766 767
767 768 # Calculate size of the chroot directory in KB
768 769 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
769 770
770 771 # Calculate the amount of needed 512 Byte sectors
771 772 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
772 773 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
773 774 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
774 775
775 776 # The root partition is EXT4
776 777 # This means more space than the actual used space of the chroot is used.
777 778 # As overhead for journaling and reserved blocks 35% are added.
778 779 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
779 780
780 781 # Calculate required image size in 512 Byte sectors
781 782 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
782 783
783 784 # Prepare image file
784 785 if [ "$ENABLE_SPLITFS" = true ] ; then
785 786 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
786 787 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
787 788 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
788 789 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
789 790
790 791 # Write firmware/boot partition tables
791 792 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
792 793 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
793 794 EOM
794 795
795 796 # Write root partition table
796 797 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
797 798 ${TABLE_SECTORS},${ROOT_SECTORS},83
798 799 EOM
799 800
800 801 # Setup temporary loop devices
801 802 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
802 803 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
803 804 else # ENABLE_SPLITFS=false
804 805 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
805 806 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
806 807
807 808 # Write partition table
808 809 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
809 810 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
810 811 ${ROOT_OFFSET},${ROOT_SECTORS},83
811 812 EOM
812 813
813 814 # Setup temporary loop devices
814 815 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
815 816 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
816 817 fi
817 818
818 819 if [ "$ENABLE_CRYPTFS" = true ] ; then
819 820 # Create dummy ext4 fs
820 821 mkfs.ext4 "$ROOT_LOOP"
821 822
822 823 # Setup password keyfile
823 824 touch .password
824 825 chmod 600 .password
825 826 echo -n ${CRYPTFS_PASSWORD} > .password
826 827
827 828 # Initialize encrypted partition
828 829 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
829 830
830 831 # Open encrypted partition and setup mapping
831 832 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
832 833
833 834 # Secure delete password keyfile
834 835 shred -zu .password
835 836
836 837 # Update temporary loop device
837 838 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
838 839
839 840 # Wipe encrypted partition (encryption cipher is used for randomness)
840 841 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
841 842 fi
842 843
843 844 # Build filesystems
844 845 mkfs.vfat "$FRMW_LOOP"
845 846 mkfs.ext4 "$ROOT_LOOP"
846 847
847 848 # Mount the temporary loop devices
848 849 mkdir -p "$BUILDDIR/mount"
849 850 mount "$ROOT_LOOP" "$BUILDDIR/mount"
850 851
851 852 mkdir -p "$BUILDDIR/mount/boot/firmware"
852 853 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
853 854
854 855 # Copy all files from the chroot to the loop device mount point directory
855 856 rsync -a "${R}/" "$BUILDDIR/mount/"
856 857
857 858 # Unmount all temporary loop devices and mount points
858 859 cleanup
859 860
860 861 # Create block map file(s) of image(s)
861 862 if [ "$ENABLE_SPLITFS" = true ] ; then
862 863 # Create block map files for "bmaptool"
863 864 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
864 865 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
865 866
866 867 # Image was successfully created
867 868 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
868 869 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
869 870 else
870 871 # Create block map file for "bmaptool"
871 872 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
872 873
873 874 # Image was successfully created
874 875 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
875 876
876 877 # Create qemu qcow2 image
877 878 if [ "$ENABLE_QEMU" = true ] ; then
878 879 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
879 880 QEMU_SIZE=16G
880 881
881 882 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
882 883 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
883 884
884 885 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
885 886 fi
886 887 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant